Imports System.Configuration
Imports System.Data.SqlClient
Imports System.Data.OleDb

Public Class _default
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
    End Sub
    Protected WithEvents dgConCSS As System.Web.UI.WebControls.DataGrid
    Protected WithEvents cmdExportCSS As System.Web.UI.WebControls.Button
    Protected WithEvents dgSinCSS As System.Web.UI.WebControls.DataGrid
    Protected WithEvents cmdExportSinCSS As System.Web.UI.WebControls.Button
    Private components As System.ComponentModel.IContainer

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    ' La cadena de conexin se guarda en el Web.config
    Private SQLServer_strConexion As String = ConfigurationSettings.AppSettings("SQLServer_strConexion")
    Private OleDb_strConexion As String = ConfigurationSettings.AppSettings("OleDb_strConexion")

    Enum dgDatos As Integer
        ConCSS = 1
        SinCSS = 2
    End Enum

    Enum ProveedorBaseDatos As Integer
        SQLServer = 1
        Access = 2
    End Enum

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Poniendo estilos al primer datagrid
        dgConCSS.PagerStyle.CssClass = "paginador"
        dgConCSS.HeaderStyle.CssClass = "cabecera"
        dgConCSS.ItemStyle.CssClass = "item"
        dgConCSS.AlternatingItemStyle.CssClass = "itemAlterno"
        ' Verificar que no se hace PostBack
        If Not Page.IsPostBack Then
            ' Carga los 2 DataGrid's
            CargarDatos(3)
        End If
    End Sub

    Private Sub CargarDatos(ByVal queDatagrid As dgDatos, _
        Optional ByVal proveedor As ProveedorBaseDatos = ProveedorBaseDatos.SQLServer)
        ' Define el DataSet
        Dim ds As DataSet
        ' Si el dataset ya est en el ViewState
        ' entonces recuperarlo de ah, para no tener que acceder a la base de datos
        ' consecutivamente
        If ViewState("datos") Is Nothing Then
            ds = New DataSet
            Dim da As IDataAdapter
            If proveedor = ProveedorBaseDatos.SQLServer Then
                da = New SqlDataAdapter("select * from TControl", SQLServer_strConexion)
            ElseIf proveedor = ProveedorBaseDatos.Access Then
                da = New OleDbDataAdapter("select * from TControl", OleDb_strConexion)
            End If
            da.Fill(ds)
            ViewState("datos") = ds
        Else
            ds = CType(ViewState("datos"), DataSet)
        End If
        ' Hace el binding para el DataGrid seleccionado
        Select Case queDatagrid
            Case dgDatos.ConCSS
                dgConCSS.DataSource = ds
                dgConCSS.DataBind()
            Case dgDatos.SinCSS
                dgSinCSS.DataSource = ds
                dgSinCSS.DataBind()
            Case Else
                dgConCSS.DataSource = ds
                dgConCSS.DataBind()
                dgSinCSS.DataSource = ds
                dgSinCSS.DataBind()
        End Select
    End Sub

    Private Sub dgConCSS_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles dgConCSS.PageIndexChanged
        dgConCSS.CurrentPageIndex = e.NewPageIndex
        ' Seleccionar el DataGrid con CSS para hacer el binding
        CargarDatos(dgDatos.ConCSS)
    End Sub

    Private Sub dgSinCSS_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles dgSinCSS.PageIndexChanged
        dgSinCSS.CurrentPageIndex = e.NewPageIndex
        ' Seleccionar el DataGrid sin CSS para hacer el binding
        CargarDatos(dgDatos.SinCSS)
    End Sub
End Class
