Imports CrystalDecisions.CrystalReports.Engine
Imports CrystalDecisions.Shared
Imports System.Configuration

Public Class reporte
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents CrystalReportViewer1 As CrystalDecisions.Web.CrystalReportViewer
    Protected WithEvents cmdExportar As System.Web.UI.WebControls.Button
    Protected WithEvents crvClientes As CrystalDecisions.Web.CrystalReportViewer
    Protected WithEvents ddlTipos As System.Web.UI.WebControls.DropDownList

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region
    ' Instancia del reporte creado, puede ser tambin un objeto ReportDocument
    ' y cargar el reporte de Clientes a travs del mtodo Load
    Private rptClientes As New Clientes
    ' Ruta de los reportes, obtenida a travs de la ruta relativa guardada en el Web.config
    Private ruta As String = Server.MapPath(ConfigurationSettings.AppSettings("rutaRpt")) & "\"
    ' Nombre por defecto con el que se intentar guardar el reporte en otro formato
    ' la extensin del archivo se concatena en el mtodo TipoDocumento
    Private nombreXdefecto As String = "ReporteClientes"
    Dim ds As DataSet

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' ***********************************************************************
        ' Aqu debera ir cdigo que utilize la Capa de Negocios o alguna otra que 
        ' crean conveniente, por ejemplo en puede haber una instancia de algn objeto
        ' que devuelva un DataSet, un DataTable, etc. 
        ' (Si se utiliza el .Net Framework 2.0, podra devolverse una lista genrica)
        Dim strConexion As String = ConfigurationSettings.AppSettings("strConexion")
        Dim da As New SqlClient.SqlDataAdapter("select * from Customers", strConexion)
        ds = New DataSet
        da.Fill(ds, "Clientes")
        ' ***********************************************************************
        ' Asigna el DataSource
        rptClientes.SetDataSource(ds.Tables("Clientes"))
        ' Asigna el reporte al CrystalReportViewer
        crvClientes.ReportSource = rptClientes
    End Sub
    ' Define el tipo de documento a enviar al cliente
    Private Function TipoDocumento() As String
        Dim tipo As String
        Select Case Integer.Parse(ddlTipos.SelectedValue) ' De acuerdo al valor seleccionado en el combo
            Case ExportFormatType.Excel
                tipo = "application/vnd.ms-excel"
                nombreXdefecto &= ".xls"
            Case ExportFormatType.RichText
                tipo = "application/rtf"
                nombreXdefecto &= ".rtf"
            Case ExportFormatType.WordForWindows
                tipo = "application/msword"
                nombreXdefecto &= ".doc"
            Case Else ' Tipo por defecto
                tipo = "application/pdf"
                nombreXdefecto &= ".pdf"
        End Select
        Return tipo
    End Function

    Private Sub cmdExportar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdExportar.Click
        ' Crea un stream
        Dim rptStream As New System.IO.MemoryStream
        ' Se exporta el reporte a un stream, luego se hace una conversin para el tipo adecuado
        rptStream = CType(rptClientes.ExportToStream(Integer.Parse(ddlTipos.SelectedValue)), System.IO.MemoryStream)
        ' Limpia el buffer
        Response.Clear()
        Response.Buffer = True
        ' Establece el tipo de documento
        Response.ContentType = TipoDocumento()
        ' Fuerza a hacer un download del archivo
        Response.AddHeader("Content-Disposition", "attachment;filename=" + Me.nombreXdefecto)
        ' Escribe el contenido del stream
        Response.BinaryWrite(rptStream.ToArray())
        Response.End()
    End Sub
End Class
